#include <strings.h>
#include <string.h>
#include <stdio.h>

int which_scale(string_t scale);

int which_scale(string_t scale) {

    /* return 1 if the temperature scale is Fahrenheit or
       F; use strcasecmp for case insensitive comparisons */

    if (strcasecmp(scale, "Fahrenheit") == 0 ||
        strcasecmp(scale, "F") == 0) {
        return 1;
    }

    /* return 2 if the temperature scale is Celsius or
       C; use strcasecmp for case insensitive comparisons */

    if (strcasecmp(scale, "Celsius") == 0 ||
        strcasecmp(scale, "C") == 0) {
        return 2;
    }

    return -1;
}

void main (int argc, string_t argv[]) {
    string_t temp_raw, scale_in_raw, scale_out_raw;
    int scale_in = -1, scale_out = -1;
    float temp_in = 0.0;

    if (argc >= 4) {
        temp_raw = argv[1];
        scale_in_raw = argv[2];
        scale_out_raw = argv[3];

        /* check if the specified input temperature contained a
           valid number */

        if (sscanf(temp_raw, "%f", &temp_in) == 1) {
            printf("Input temperature: '%f' degrees\n",
                   temp_in);
        } else {
            printf("Invalid input temperature: '%s' degrees\n",
                   temp_raw);
        }

        /* verify that the input temperature scale was either
           Fahrenheit or Celsius */

        scale_in = which_scale(scale_in_raw);
        if (scale_in == 1 || scale_in == 2) {
            printf("Input temperature scale: '%s'\n",
                   scale_in_raw);
        } else {
            printf("Invalid input temperature scale: '%s'\n",
                   scale_in_raw);
        }

        /* verify that the output temperature scale was either
           Fahrenheit or Celsius */

        scale_out = which_scale(scale_out_raw);
        if (scale_out == 1 || scale_out == 2) {
            printf("Output temperature scale: '%s'\n",
                   scale_out_raw);
        } else {
            printf("Invalid output temperature scale: '%s'\n",
                   scale_out_raw);
        }

        if (scale_in == scale_out) {
            printf("Input and output scales are the same\n");
        }

    } else {
        printf("Please specify the temperature and scales.\n");
    }
}

