#include <strings.h>
#include <string.h>
#include <stdio.h>

enum {
    SCALE_F = 1,
    SCALE_C = 2
};

int which_scale(string_t scale) {
    if (strcasecmp(scale, "Fahrenheit") == 0 ||
        strcasecmp(scale, "F") == 0) {
        return SCALE_F;
    }

    if (strcasecmp(scale, "Celsius") == 0 ||
        strcasecmp(scale, "C") == 0) {
        return SCALE_C;
    }

    return -1;
}

void main (int argc, string_t argv[]) {
    string_t temp_raw, scale_in_raw, scale_out_raw;
    int scale_in = -1, scale_out = -1;
    float temp_in = 0.0;

    if (argc >= 4) {
        temp_raw = argv[1];
        scale_in_raw = argv[2];
        scale_out_raw = argv[3];

        if (sscanf(temp_raw, "%f", &temp_in) == 1) {
            printf("Input temperature: '%f' degrees\n",
                   temp_in);
        } else {
            printf("Invalid input temperature: '%s' degrees\n",
                   temp_raw);
        }

        scale_in = which_scale(scale_in_raw);

        if (scale_in == SCALE_F || scale_in == SCALE_C) {
            printf("Input temperature scale: '%s'\n",
                   scale_in_raw);
        } else {
            printf("Invalid input temperature scale: '%s'\n",
                   scale_in_raw);
        }

        scale_out = which_scale(scale_out_raw);

        if (scale_out == SCALE_F || scale_out == SCALE_C) {
            printf("Output temperature scale: '%s'\n",
                   scale_out_raw);
        } else {
            printf("Invalid output temperature scale: '%s'\n",
                   scale_out_raw);
        }

        if (scale_in == scale_out) {
            printf("Input and output scales are the same\n");
        }

    } else {
        printf("Please specify the temperature and scales.\n");
    }
}

